#ifndef __included_igmp_api_json
#define __included_igmp_api_json

#include <stdlib.h>
#include <stddef.h>
#include <arpa/inet.h>
#include <vapi/vapi_internal.h>
#include <vapi/vapi.h>
#include <vapi/vapi_dbg.h>

#ifdef __cplusplus
extern "C" {
#endif
#include <vapi/vpe.api.vapi.h>

extern vapi_msg_id_t vapi_msg_id_want_igmp_events;
extern vapi_msg_id_t vapi_msg_id_igmp_details;
extern vapi_msg_id_t vapi_msg_id_igmp_listen_reply;
extern vapi_msg_id_t vapi_msg_id_igmp_event;
extern vapi_msg_id_t vapi_msg_id_igmp_dump;
extern vapi_msg_id_t vapi_msg_id_igmp_enable_disable;
extern vapi_msg_id_t vapi_msg_id_igmp_clear_interface;
extern vapi_msg_id_t vapi_msg_id_want_igmp_events_reply;
extern vapi_msg_id_t vapi_msg_id_igmp_enable_disable_reply;
extern vapi_msg_id_t vapi_msg_id_igmp_listen;
extern vapi_msg_id_t vapi_msg_id_igmp_clear_interface_reply;

#define DEFINE_VAPI_MSG_IDS_IGMP_API_JSON\
  vapi_msg_id_t vapi_msg_id_want_igmp_events;\
  vapi_msg_id_t vapi_msg_id_igmp_details;\
  vapi_msg_id_t vapi_msg_id_igmp_listen_reply;\
  vapi_msg_id_t vapi_msg_id_igmp_event;\
  vapi_msg_id_t vapi_msg_id_igmp_dump;\
  vapi_msg_id_t vapi_msg_id_igmp_enable_disable;\
  vapi_msg_id_t vapi_msg_id_igmp_clear_interface;\
  vapi_msg_id_t vapi_msg_id_want_igmp_events_reply;\
  vapi_msg_id_t vapi_msg_id_igmp_enable_disable_reply;\
  vapi_msg_id_t vapi_msg_id_igmp_listen;\
  vapi_msg_id_t vapi_msg_id_igmp_clear_interface_reply;


#ifndef defined_vapi_payload_want_igmp_events
#define defined_vapi_payload_want_igmp_events
typedef struct __attribute__ ((__packed__)) {
  u32 enable;
  u32 pid; 
} vapi_payload_want_igmp_events;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_want_igmp_events payload;
} vapi_msg_want_igmp_events;
#endif

#ifndef defined_vapi_payload_igmp_details
#define defined_vapi_payload_igmp_details
typedef struct __attribute__ ((__packed__)) {
  u32 sw_if_index;
  u8 saddr[4];
  u8 gaddr[4]; 
} vapi_payload_igmp_details;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_igmp_details payload;
} vapi_msg_igmp_details;
#endif

#ifndef defined_vapi_payload_igmp_listen_reply
#define defined_vapi_payload_igmp_listen_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_igmp_listen_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_igmp_listen_reply payload;
} vapi_msg_igmp_listen_reply;
#endif

#ifndef defined_vapi_payload_igmp_event
#define defined_vapi_payload_igmp_event
typedef struct __attribute__ ((__packed__)) {
  u32 sw_if_index;
  u8 saddr[4];
  u8 gaddr[4];
  u8 is_join; 
} vapi_payload_igmp_event;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_igmp_event payload;
} vapi_msg_igmp_event;
#endif

#ifndef defined_vapi_payload_igmp_dump
#define defined_vapi_payload_igmp_dump
typedef struct __attribute__ ((__packed__)) {
  u32 sw_if_index;
  u8 dump_all; 
} vapi_payload_igmp_dump;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_igmp_dump payload;
} vapi_msg_igmp_dump;
#endif

#ifndef defined_vapi_payload_igmp_enable_disable
#define defined_vapi_payload_igmp_enable_disable
typedef struct __attribute__ ((__packed__)) {
  u8 enable;
  u32 sw_if_index; 
} vapi_payload_igmp_enable_disable;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_igmp_enable_disable payload;
} vapi_msg_igmp_enable_disable;
#endif

#ifndef defined_vapi_payload_igmp_clear_interface
#define defined_vapi_payload_igmp_clear_interface
typedef struct __attribute__ ((__packed__)) {
  u32 sw_if_index; 
} vapi_payload_igmp_clear_interface;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_igmp_clear_interface payload;
} vapi_msg_igmp_clear_interface;
#endif

#ifndef defined_vapi_payload_want_igmp_events_reply
#define defined_vapi_payload_want_igmp_events_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_want_igmp_events_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_want_igmp_events_reply payload;
} vapi_msg_want_igmp_events_reply;
#endif

#ifndef defined_vapi_payload_igmp_enable_disable_reply
#define defined_vapi_payload_igmp_enable_disable_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_igmp_enable_disable_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_igmp_enable_disable_reply payload;
} vapi_msg_igmp_enable_disable_reply;
#endif

#ifndef defined_vapi_payload_igmp_listen
#define defined_vapi_payload_igmp_listen
typedef struct __attribute__ ((__packed__)) {
  u8 enable;
  u32 sw_if_index;
  u8 saddr[4];
  u8 gaddr[4]; 
} vapi_payload_igmp_listen;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_igmp_listen payload;
} vapi_msg_igmp_listen;
#endif

#ifndef defined_vapi_payload_igmp_clear_interface_reply
#define defined_vapi_payload_igmp_clear_interface_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_igmp_clear_interface_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_igmp_clear_interface_reply payload;
} vapi_msg_igmp_clear_interface_reply;
#endif


static inline void vapi_msg_want_igmp_events_payload_hton(vapi_payload_want_igmp_events *payload)
{
  payload->enable = htobe32(payload->enable);
  payload->pid = htobe32(payload->pid);
}

static inline void vapi_msg_want_igmp_events_payload_ntoh(vapi_payload_want_igmp_events *payload)
{
  payload->enable = be32toh(payload->enable);
  payload->pid = be32toh(payload->pid);
}

static inline uword vapi_calc_want_igmp_events_msg_size(vapi_msg_want_igmp_events *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_want_igmp_events_hton(vapi_msg_want_igmp_events *msg)
{
  VAPI_DBG("Swapping `vapi_msg_want_igmp_events'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_want_igmp_events_payload_hton(&msg->payload);
}

static inline void vapi_msg_want_igmp_events_ntoh(vapi_msg_want_igmp_events *msg)
{
  VAPI_DBG("Swapping `vapi_msg_want_igmp_events'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_want_igmp_events_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_igmp_details_payload_hton(vapi_payload_igmp_details *payload)
{
  payload->sw_if_index = htobe32(payload->sw_if_index);
}

static inline void vapi_msg_igmp_details_payload_ntoh(vapi_payload_igmp_details *payload)
{
  payload->sw_if_index = be32toh(payload->sw_if_index);
}

static inline uword vapi_calc_igmp_details_msg_size(vapi_msg_igmp_details *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_igmp_details_hton(vapi_msg_igmp_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_igmp_details'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_igmp_details_payload_hton(&msg->payload);
}

static inline void vapi_msg_igmp_details_ntoh(vapi_msg_igmp_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_igmp_details'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_igmp_details_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_igmp_listen_reply_payload_hton(vapi_payload_igmp_listen_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_igmp_listen_reply_payload_ntoh(vapi_payload_igmp_listen_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_igmp_listen_reply_msg_size(vapi_msg_igmp_listen_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_igmp_listen_reply_hton(vapi_msg_igmp_listen_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_igmp_listen_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_igmp_listen_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_igmp_listen_reply_ntoh(vapi_msg_igmp_listen_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_igmp_listen_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_igmp_listen_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_igmp_event_payload_hton(vapi_payload_igmp_event *payload)
{
  payload->sw_if_index = htobe32(payload->sw_if_index);
}

static inline void vapi_msg_igmp_event_payload_ntoh(vapi_payload_igmp_event *payload)
{
  payload->sw_if_index = be32toh(payload->sw_if_index);
}

static inline uword vapi_calc_igmp_event_msg_size(vapi_msg_igmp_event *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_igmp_event_hton(vapi_msg_igmp_event *msg)
{
  VAPI_DBG("Swapping `vapi_msg_igmp_event'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_igmp_event_payload_hton(&msg->payload);
}

static inline void vapi_msg_igmp_event_ntoh(vapi_msg_igmp_event *msg)
{
  VAPI_DBG("Swapping `vapi_msg_igmp_event'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_igmp_event_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_igmp_dump_payload_hton(vapi_payload_igmp_dump *payload)
{
  payload->sw_if_index = htobe32(payload->sw_if_index);
}

static inline void vapi_msg_igmp_dump_payload_ntoh(vapi_payload_igmp_dump *payload)
{
  payload->sw_if_index = be32toh(payload->sw_if_index);
}

static inline uword vapi_calc_igmp_dump_msg_size(vapi_msg_igmp_dump *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_igmp_dump_hton(vapi_msg_igmp_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_igmp_dump'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_igmp_dump_payload_hton(&msg->payload);
}

static inline void vapi_msg_igmp_dump_ntoh(vapi_msg_igmp_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_igmp_dump'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_igmp_dump_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_igmp_enable_disable_payload_hton(vapi_payload_igmp_enable_disable *payload)
{
  payload->sw_if_index = htobe32(payload->sw_if_index);
}

static inline void vapi_msg_igmp_enable_disable_payload_ntoh(vapi_payload_igmp_enable_disable *payload)
{
  payload->sw_if_index = be32toh(payload->sw_if_index);
}

static inline uword vapi_calc_igmp_enable_disable_msg_size(vapi_msg_igmp_enable_disable *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_igmp_enable_disable_hton(vapi_msg_igmp_enable_disable *msg)
{
  VAPI_DBG("Swapping `vapi_msg_igmp_enable_disable'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_igmp_enable_disable_payload_hton(&msg->payload);
}

static inline void vapi_msg_igmp_enable_disable_ntoh(vapi_msg_igmp_enable_disable *msg)
{
  VAPI_DBG("Swapping `vapi_msg_igmp_enable_disable'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_igmp_enable_disable_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_igmp_clear_interface_payload_hton(vapi_payload_igmp_clear_interface *payload)
{
  payload->sw_if_index = htobe32(payload->sw_if_index);
}

static inline void vapi_msg_igmp_clear_interface_payload_ntoh(vapi_payload_igmp_clear_interface *payload)
{
  payload->sw_if_index = be32toh(payload->sw_if_index);
}

static inline uword vapi_calc_igmp_clear_interface_msg_size(vapi_msg_igmp_clear_interface *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_igmp_clear_interface_hton(vapi_msg_igmp_clear_interface *msg)
{
  VAPI_DBG("Swapping `vapi_msg_igmp_clear_interface'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_igmp_clear_interface_payload_hton(&msg->payload);
}

static inline void vapi_msg_igmp_clear_interface_ntoh(vapi_msg_igmp_clear_interface *msg)
{
  VAPI_DBG("Swapping `vapi_msg_igmp_clear_interface'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_igmp_clear_interface_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_want_igmp_events_reply_payload_hton(vapi_payload_want_igmp_events_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_want_igmp_events_reply_payload_ntoh(vapi_payload_want_igmp_events_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_want_igmp_events_reply_msg_size(vapi_msg_want_igmp_events_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_want_igmp_events_reply_hton(vapi_msg_want_igmp_events_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_want_igmp_events_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_want_igmp_events_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_want_igmp_events_reply_ntoh(vapi_msg_want_igmp_events_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_want_igmp_events_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_want_igmp_events_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_igmp_enable_disable_reply_payload_hton(vapi_payload_igmp_enable_disable_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_igmp_enable_disable_reply_payload_ntoh(vapi_payload_igmp_enable_disable_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_igmp_enable_disable_reply_msg_size(vapi_msg_igmp_enable_disable_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_igmp_enable_disable_reply_hton(vapi_msg_igmp_enable_disable_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_igmp_enable_disable_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_igmp_enable_disable_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_igmp_enable_disable_reply_ntoh(vapi_msg_igmp_enable_disable_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_igmp_enable_disable_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_igmp_enable_disable_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_igmp_listen_payload_hton(vapi_payload_igmp_listen *payload)
{
  payload->sw_if_index = htobe32(payload->sw_if_index);
}

static inline void vapi_msg_igmp_listen_payload_ntoh(vapi_payload_igmp_listen *payload)
{
  payload->sw_if_index = be32toh(payload->sw_if_index);
}

static inline uword vapi_calc_igmp_listen_msg_size(vapi_msg_igmp_listen *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_igmp_listen_hton(vapi_msg_igmp_listen *msg)
{
  VAPI_DBG("Swapping `vapi_msg_igmp_listen'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_igmp_listen_payload_hton(&msg->payload);
}

static inline void vapi_msg_igmp_listen_ntoh(vapi_msg_igmp_listen *msg)
{
  VAPI_DBG("Swapping `vapi_msg_igmp_listen'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_igmp_listen_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_igmp_clear_interface_reply_payload_hton(vapi_payload_igmp_clear_interface_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_igmp_clear_interface_reply_payload_ntoh(vapi_payload_igmp_clear_interface_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_igmp_clear_interface_reply_msg_size(vapi_msg_igmp_clear_interface_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_igmp_clear_interface_reply_hton(vapi_msg_igmp_clear_interface_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_igmp_clear_interface_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_igmp_clear_interface_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_igmp_clear_interface_reply_ntoh(vapi_msg_igmp_clear_interface_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_igmp_clear_interface_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_igmp_clear_interface_reply_payload_ntoh(&msg->payload);
}

static inline vapi_msg_want_igmp_events* vapi_alloc_want_igmp_events(struct vapi_ctx_s *ctx)
{
  vapi_msg_want_igmp_events *msg = NULL;
  const size_t size = sizeof(vapi_msg_want_igmp_events);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_want_igmp_events*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_want_igmp_events);

  return msg;
}

static inline vapi_error_e vapi_want_igmp_events(struct vapi_ctx_s *ctx,
  vapi_msg_want_igmp_events *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_want_igmp_events_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_want_igmp_events_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_want_igmp_events_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_igmp_dump* vapi_alloc_igmp_dump(struct vapi_ctx_s *ctx)
{
  vapi_msg_igmp_dump *msg = NULL;
  const size_t size = sizeof(vapi_msg_igmp_dump);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_igmp_dump*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_igmp_dump);

  return msg;
}

static inline vapi_error_e vapi_igmp_dump(struct vapi_ctx_s *ctx,
  vapi_msg_igmp_dump *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_igmp_details *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_igmp_dump_hton(msg);
  if (VAPI_OK == (rv = vapi_send_with_control_ping (ctx, msg, req_context))) {
    vapi_store_request(ctx, req_context, true, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_igmp_dump_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_igmp_enable_disable* vapi_alloc_igmp_enable_disable(struct vapi_ctx_s *ctx)
{
  vapi_msg_igmp_enable_disable *msg = NULL;
  const size_t size = sizeof(vapi_msg_igmp_enable_disable);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_igmp_enable_disable*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_igmp_enable_disable);

  return msg;
}

static inline vapi_error_e vapi_igmp_enable_disable(struct vapi_ctx_s *ctx,
  vapi_msg_igmp_enable_disable *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_igmp_enable_disable_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_igmp_enable_disable_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_igmp_enable_disable_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_igmp_clear_interface* vapi_alloc_igmp_clear_interface(struct vapi_ctx_s *ctx)
{
  vapi_msg_igmp_clear_interface *msg = NULL;
  const size_t size = sizeof(vapi_msg_igmp_clear_interface);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_igmp_clear_interface*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_igmp_clear_interface);

  return msg;
}

static inline vapi_error_e vapi_igmp_clear_interface(struct vapi_ctx_s *ctx,
  vapi_msg_igmp_clear_interface *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_igmp_clear_interface_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_igmp_clear_interface_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_igmp_clear_interface_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_igmp_listen* vapi_alloc_igmp_listen(struct vapi_ctx_s *ctx)
{
  vapi_msg_igmp_listen *msg = NULL;
  const size_t size = sizeof(vapi_msg_igmp_listen);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_igmp_listen*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_igmp_listen);

  return msg;
}

static inline vapi_error_e vapi_igmp_listen(struct vapi_ctx_s *ctx,
  vapi_msg_igmp_listen *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_igmp_listen_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_igmp_listen_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_igmp_listen_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}



static void __attribute__((constructor)) __vapi_constructor_want_igmp_events()
{
  static const char name[] = "want_igmp_events";
  static const char name_with_crc[] = "want_igmp_events_cfaccc1f";
  static vapi_message_desc_t __vapi_metadata_want_igmp_events = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_want_igmp_events, payload),
    sizeof(vapi_msg_want_igmp_events),
    (generic_swap_fn_t)vapi_msg_want_igmp_events_hton,
    (generic_swap_fn_t)vapi_msg_want_igmp_events_ntoh,
    INVALID_MSG_ID,
  };

  vapi_msg_id_want_igmp_events = vapi_register_msg(&__vapi_metadata_want_igmp_events);
  VAPI_DBG("Assigned msg id %d to want_igmp_events", vapi_msg_id_want_igmp_events);
}

static void __attribute__((constructor)) __vapi_constructor_igmp_details()
{
  static const char name[] = "igmp_details";
  static const char name_with_crc[] = "igmp_details_10046048";
  static vapi_message_desc_t __vapi_metadata_igmp_details = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_igmp_details, payload),
    sizeof(vapi_msg_igmp_details),
    (generic_swap_fn_t)vapi_msg_igmp_details_hton,
    (generic_swap_fn_t)vapi_msg_igmp_details_ntoh,
    INVALID_MSG_ID,
  };

  vapi_msg_id_igmp_details = vapi_register_msg(&__vapi_metadata_igmp_details);
  VAPI_DBG("Assigned msg id %d to igmp_details", vapi_msg_id_igmp_details);
}

static void __attribute__((constructor)) __vapi_constructor_igmp_listen_reply()
{
  static const char name[] = "igmp_listen_reply";
  static const char name_with_crc[] = "igmp_listen_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_igmp_listen_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_igmp_listen_reply, payload),
    sizeof(vapi_msg_igmp_listen_reply),
    (generic_swap_fn_t)vapi_msg_igmp_listen_reply_hton,
    (generic_swap_fn_t)vapi_msg_igmp_listen_reply_ntoh,
    INVALID_MSG_ID,
  };

  vapi_msg_id_igmp_listen_reply = vapi_register_msg(&__vapi_metadata_igmp_listen_reply);
  VAPI_DBG("Assigned msg id %d to igmp_listen_reply", vapi_msg_id_igmp_listen_reply);
}

static void __attribute__((constructor)) __vapi_constructor_igmp_event()
{
  static const char name[] = "igmp_event";
  static const char name_with_crc[] = "igmp_event_41eed830";
  static vapi_message_desc_t __vapi_metadata_igmp_event = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_igmp_event, payload),
    sizeof(vapi_msg_igmp_event),
    (generic_swap_fn_t)vapi_msg_igmp_event_hton,
    (generic_swap_fn_t)vapi_msg_igmp_event_ntoh,
    INVALID_MSG_ID,
  };

  vapi_msg_id_igmp_event = vapi_register_msg(&__vapi_metadata_igmp_event);
  VAPI_DBG("Assigned msg id %d to igmp_event", vapi_msg_id_igmp_event);
}

static void __attribute__((constructor)) __vapi_constructor_igmp_dump()
{
  static const char name[] = "igmp_dump";
  static const char name_with_crc[] = "igmp_dump_c2293185";
  static vapi_message_desc_t __vapi_metadata_igmp_dump = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_igmp_dump, payload),
    sizeof(vapi_msg_igmp_dump),
    (generic_swap_fn_t)vapi_msg_igmp_dump_hton,
    (generic_swap_fn_t)vapi_msg_igmp_dump_ntoh,
    INVALID_MSG_ID,
  };

  vapi_msg_id_igmp_dump = vapi_register_msg(&__vapi_metadata_igmp_dump);
  VAPI_DBG("Assigned msg id %d to igmp_dump", vapi_msg_id_igmp_dump);
}

static void __attribute__((constructor)) __vapi_constructor_igmp_enable_disable()
{
  static const char name[] = "igmp_enable_disable";
  static const char name_with_crc[] = "igmp_enable_disable_be783837";
  static vapi_message_desc_t __vapi_metadata_igmp_enable_disable = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_igmp_enable_disable, payload),
    sizeof(vapi_msg_igmp_enable_disable),
    (generic_swap_fn_t)vapi_msg_igmp_enable_disable_hton,
    (generic_swap_fn_t)vapi_msg_igmp_enable_disable_ntoh,
    INVALID_MSG_ID,
  };

  vapi_msg_id_igmp_enable_disable = vapi_register_msg(&__vapi_metadata_igmp_enable_disable);
  VAPI_DBG("Assigned msg id %d to igmp_enable_disable", vapi_msg_id_igmp_enable_disable);
}

static void __attribute__((constructor)) __vapi_constructor_igmp_clear_interface()
{
  static const char name[] = "igmp_clear_interface";
  static const char name_with_crc[] = "igmp_clear_interface_529cb13f";
  static vapi_message_desc_t __vapi_metadata_igmp_clear_interface = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_igmp_clear_interface, payload),
    sizeof(vapi_msg_igmp_clear_interface),
    (generic_swap_fn_t)vapi_msg_igmp_clear_interface_hton,
    (generic_swap_fn_t)vapi_msg_igmp_clear_interface_ntoh,
    INVALID_MSG_ID,
  };

  vapi_msg_id_igmp_clear_interface = vapi_register_msg(&__vapi_metadata_igmp_clear_interface);
  VAPI_DBG("Assigned msg id %d to igmp_clear_interface", vapi_msg_id_igmp_clear_interface);
}

static void __attribute__((constructor)) __vapi_constructor_want_igmp_events_reply()
{
  static const char name[] = "want_igmp_events_reply";
  static const char name_with_crc[] = "want_igmp_events_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_want_igmp_events_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_want_igmp_events_reply, payload),
    sizeof(vapi_msg_want_igmp_events_reply),
    (generic_swap_fn_t)vapi_msg_want_igmp_events_reply_hton,
    (generic_swap_fn_t)vapi_msg_want_igmp_events_reply_ntoh,
    INVALID_MSG_ID,
  };

  vapi_msg_id_want_igmp_events_reply = vapi_register_msg(&__vapi_metadata_want_igmp_events_reply);
  VAPI_DBG("Assigned msg id %d to want_igmp_events_reply", vapi_msg_id_want_igmp_events_reply);
}

static void __attribute__((constructor)) __vapi_constructor_igmp_enable_disable_reply()
{
  static const char name[] = "igmp_enable_disable_reply";
  static const char name_with_crc[] = "igmp_enable_disable_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_igmp_enable_disable_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_igmp_enable_disable_reply, payload),
    sizeof(vapi_msg_igmp_enable_disable_reply),
    (generic_swap_fn_t)vapi_msg_igmp_enable_disable_reply_hton,
    (generic_swap_fn_t)vapi_msg_igmp_enable_disable_reply_ntoh,
    INVALID_MSG_ID,
  };

  vapi_msg_id_igmp_enable_disable_reply = vapi_register_msg(&__vapi_metadata_igmp_enable_disable_reply);
  VAPI_DBG("Assigned msg id %d to igmp_enable_disable_reply", vapi_msg_id_igmp_enable_disable_reply);
}

static void __attribute__((constructor)) __vapi_constructor_igmp_listen()
{
  static const char name[] = "igmp_listen";
  static const char name_with_crc[] = "igmp_listen_8a000d96";
  static vapi_message_desc_t __vapi_metadata_igmp_listen = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_igmp_listen, payload),
    sizeof(vapi_msg_igmp_listen),
    (generic_swap_fn_t)vapi_msg_igmp_listen_hton,
    (generic_swap_fn_t)vapi_msg_igmp_listen_ntoh,
    INVALID_MSG_ID,
  };

  vapi_msg_id_igmp_listen = vapi_register_msg(&__vapi_metadata_igmp_listen);
  VAPI_DBG("Assigned msg id %d to igmp_listen", vapi_msg_id_igmp_listen);
}

static void __attribute__((constructor)) __vapi_constructor_igmp_clear_interface_reply()
{
  static const char name[] = "igmp_clear_interface_reply";
  static const char name_with_crc[] = "igmp_clear_interface_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_igmp_clear_interface_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_igmp_clear_interface_reply, payload),
    sizeof(vapi_msg_igmp_clear_interface_reply),
    (generic_swap_fn_t)vapi_msg_igmp_clear_interface_reply_hton,
    (generic_swap_fn_t)vapi_msg_igmp_clear_interface_reply_ntoh,
    INVALID_MSG_ID,
  };

  vapi_msg_id_igmp_clear_interface_reply = vapi_register_msg(&__vapi_metadata_igmp_clear_interface_reply);
  VAPI_DBG("Assigned msg id %d to igmp_clear_interface_reply", vapi_msg_id_igmp_clear_interface_reply);
}


static inline void vapi_set_vapi_msg_igmp_details_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_igmp_details *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_igmp_details, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_igmp_listen_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_igmp_listen_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_igmp_listen_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_igmp_event_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_igmp_event *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_igmp_event, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_want_igmp_events_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_want_igmp_events_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_want_igmp_events_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_igmp_enable_disable_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_igmp_enable_disable_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_igmp_enable_disable_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_igmp_clear_interface_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_igmp_clear_interface_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_igmp_clear_interface_reply, (vapi_event_cb)callback, callback_ctx);
};


#ifdef __cplusplus
}
#endif

#endif
