#ifndef __included_kp_api_json
#define __included_kp_api_json

#include <stdlib.h>
#include <stddef.h>
#include <arpa/inet.h>
#include <vapi/vapi_internal.h>
#include <vapi/vapi.h>
#include <vapi/vapi_dbg.h>

#ifdef __cplusplus
extern "C" {
#endif
#include <vapi/vpe.api.vapi.h>

extern vapi_msg_id_t vapi_msg_id_kp_conf;
extern vapi_msg_id_t vapi_msg_id_kp_add_del_pod;
extern vapi_msg_id_t vapi_msg_id_kp_add_del_pod_reply;
extern vapi_msg_id_t vapi_msg_id_kp_add_del_vip;
extern vapi_msg_id_t vapi_msg_id_kp_add_del_vip_reply;
extern vapi_msg_id_t vapi_msg_id_kp_conf_reply;

#define DEFINE_VAPI_MSG_IDS_KP_API_JSON\
  vapi_msg_id_t vapi_msg_id_kp_conf;\
  vapi_msg_id_t vapi_msg_id_kp_add_del_pod;\
  vapi_msg_id_t vapi_msg_id_kp_add_del_pod_reply;\
  vapi_msg_id_t vapi_msg_id_kp_add_del_vip;\
  vapi_msg_id_t vapi_msg_id_kp_add_del_vip_reply;\
  vapi_msg_id_t vapi_msg_id_kp_conf_reply;


#ifndef defined_vapi_payload_kp_conf
#define defined_vapi_payload_kp_conf
typedef struct __attribute__ ((__packed__)) {
  u32 sticky_buckets_per_core;
  u32 flow_timeout; 
} vapi_payload_kp_conf;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_kp_conf payload;
} vapi_msg_kp_conf;
#endif

#ifndef defined_vapi_payload_kp_add_del_pod
#define defined_vapi_payload_kp_add_del_pod
typedef struct __attribute__ ((__packed__)) {
  u8 vip_ip_prefix[16];
  u8 vip_prefix_length;
  u8 vip_is_ipv6;
  u8 pod_address[16];
  u8 pod_is_ipv6;
  u8 is_del; 
} vapi_payload_kp_add_del_pod;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_kp_add_del_pod payload;
} vapi_msg_kp_add_del_pod;
#endif

#ifndef defined_vapi_payload_kp_add_del_pod_reply
#define defined_vapi_payload_kp_add_del_pod_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_kp_add_del_pod_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_kp_add_del_pod_reply payload;
} vapi_msg_kp_add_del_pod_reply;
#endif

#ifndef defined_vapi_payload_kp_add_del_vip
#define defined_vapi_payload_kp_add_del_vip
typedef struct __attribute__ ((__packed__)) {
  u8 ip_prefix[16];
  u8 prefix_length;
  u8 is_ipv6;
  u16 port;
  u16 target_port;
  u16 node_port;
  u8 is_nat4;
  u32 new_flows_table_length;
  u8 is_del; 
} vapi_payload_kp_add_del_vip;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_kp_add_del_vip payload;
} vapi_msg_kp_add_del_vip;
#endif

#ifndef defined_vapi_payload_kp_add_del_vip_reply
#define defined_vapi_payload_kp_add_del_vip_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_kp_add_del_vip_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_kp_add_del_vip_reply payload;
} vapi_msg_kp_add_del_vip_reply;
#endif

#ifndef defined_vapi_payload_kp_conf_reply
#define defined_vapi_payload_kp_conf_reply
typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_kp_conf_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_kp_conf_reply payload;
} vapi_msg_kp_conf_reply;
#endif


static inline void vapi_msg_kp_conf_payload_hton(vapi_payload_kp_conf *payload)
{
  payload->sticky_buckets_per_core = htobe32(payload->sticky_buckets_per_core);
  payload->flow_timeout = htobe32(payload->flow_timeout);
}

static inline void vapi_msg_kp_conf_payload_ntoh(vapi_payload_kp_conf *payload)
{
  payload->sticky_buckets_per_core = be32toh(payload->sticky_buckets_per_core);
  payload->flow_timeout = be32toh(payload->flow_timeout);
}

static inline uword vapi_calc_kp_conf_msg_size(vapi_msg_kp_conf *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_kp_conf_hton(vapi_msg_kp_conf *msg)
{
  VAPI_DBG("Swapping `vapi_msg_kp_conf'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_kp_conf_payload_hton(&msg->payload);
}

static inline void vapi_msg_kp_conf_ntoh(vapi_msg_kp_conf *msg)
{
  VAPI_DBG("Swapping `vapi_msg_kp_conf'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_kp_conf_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_kp_add_del_pod_payload_hton(vapi_payload_kp_add_del_pod *payload)
{

}

static inline void vapi_msg_kp_add_del_pod_payload_ntoh(vapi_payload_kp_add_del_pod *payload)
{

}

static inline uword vapi_calc_kp_add_del_pod_msg_size(vapi_msg_kp_add_del_pod *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_kp_add_del_pod_hton(vapi_msg_kp_add_del_pod *msg)
{
  VAPI_DBG("Swapping `vapi_msg_kp_add_del_pod'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_kp_add_del_pod_payload_hton(&msg->payload);
}

static inline void vapi_msg_kp_add_del_pod_ntoh(vapi_msg_kp_add_del_pod *msg)
{
  VAPI_DBG("Swapping `vapi_msg_kp_add_del_pod'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_kp_add_del_pod_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_kp_add_del_pod_reply_payload_hton(vapi_payload_kp_add_del_pod_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_kp_add_del_pod_reply_payload_ntoh(vapi_payload_kp_add_del_pod_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_kp_add_del_pod_reply_msg_size(vapi_msg_kp_add_del_pod_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_kp_add_del_pod_reply_hton(vapi_msg_kp_add_del_pod_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_kp_add_del_pod_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_kp_add_del_pod_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_kp_add_del_pod_reply_ntoh(vapi_msg_kp_add_del_pod_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_kp_add_del_pod_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_kp_add_del_pod_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_kp_add_del_vip_payload_hton(vapi_payload_kp_add_del_vip *payload)
{
  payload->port = htobe16(payload->port);
  payload->target_port = htobe16(payload->target_port);
  payload->node_port = htobe16(payload->node_port);
  payload->new_flows_table_length = htobe32(payload->new_flows_table_length);
}

static inline void vapi_msg_kp_add_del_vip_payload_ntoh(vapi_payload_kp_add_del_vip *payload)
{
  payload->port = be16toh(payload->port);
  payload->target_port = be16toh(payload->target_port);
  payload->node_port = be16toh(payload->node_port);
  payload->new_flows_table_length = be32toh(payload->new_flows_table_length);
}

static inline uword vapi_calc_kp_add_del_vip_msg_size(vapi_msg_kp_add_del_vip *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_kp_add_del_vip_hton(vapi_msg_kp_add_del_vip *msg)
{
  VAPI_DBG("Swapping `vapi_msg_kp_add_del_vip'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_kp_add_del_vip_payload_hton(&msg->payload);
}

static inline void vapi_msg_kp_add_del_vip_ntoh(vapi_msg_kp_add_del_vip *msg)
{
  VAPI_DBG("Swapping `vapi_msg_kp_add_del_vip'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_kp_add_del_vip_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_kp_add_del_vip_reply_payload_hton(vapi_payload_kp_add_del_vip_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_kp_add_del_vip_reply_payload_ntoh(vapi_payload_kp_add_del_vip_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_kp_add_del_vip_reply_msg_size(vapi_msg_kp_add_del_vip_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_kp_add_del_vip_reply_hton(vapi_msg_kp_add_del_vip_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_kp_add_del_vip_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_kp_add_del_vip_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_kp_add_del_vip_reply_ntoh(vapi_msg_kp_add_del_vip_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_kp_add_del_vip_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_kp_add_del_vip_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_kp_conf_reply_payload_hton(vapi_payload_kp_conf_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_kp_conf_reply_payload_ntoh(vapi_payload_kp_conf_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_kp_conf_reply_msg_size(vapi_msg_kp_conf_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_kp_conf_reply_hton(vapi_msg_kp_conf_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_kp_conf_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_kp_conf_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_kp_conf_reply_ntoh(vapi_msg_kp_conf_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_kp_conf_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_kp_conf_reply_payload_ntoh(&msg->payload);
}

static inline vapi_msg_kp_conf* vapi_alloc_kp_conf(struct vapi_ctx_s *ctx)
{
  vapi_msg_kp_conf *msg = NULL;
  const size_t size = sizeof(vapi_msg_kp_conf);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_kp_conf*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_kp_conf);

  return msg;
}

static inline vapi_error_e vapi_kp_conf(struct vapi_ctx_s *ctx,
  vapi_msg_kp_conf *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_kp_conf_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_kp_conf_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_kp_conf_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_kp_add_del_pod* vapi_alloc_kp_add_del_pod(struct vapi_ctx_s *ctx)
{
  vapi_msg_kp_add_del_pod *msg = NULL;
  const size_t size = sizeof(vapi_msg_kp_add_del_pod);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_kp_add_del_pod*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_kp_add_del_pod);

  return msg;
}

static inline vapi_error_e vapi_kp_add_del_pod(struct vapi_ctx_s *ctx,
  vapi_msg_kp_add_del_pod *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_kp_add_del_pod_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_kp_add_del_pod_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_kp_add_del_pod_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_kp_add_del_vip* vapi_alloc_kp_add_del_vip(struct vapi_ctx_s *ctx)
{
  vapi_msg_kp_add_del_vip *msg = NULL;
  const size_t size = sizeof(vapi_msg_kp_add_del_vip);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_kp_add_del_vip*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_kp_add_del_vip);

  return msg;
}

static inline vapi_error_e vapi_kp_add_del_vip(struct vapi_ctx_s *ctx,
  vapi_msg_kp_add_del_vip *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_kp_add_del_vip_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_kp_add_del_vip_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_kp_add_del_vip_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}



static void __attribute__((constructor)) __vapi_constructor_kp_conf()
{
  static const char name[] = "kp_conf";
  static const char name_with_crc[] = "kp_conf_f8eac047";
  static vapi_message_desc_t __vapi_metadata_kp_conf = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_kp_conf, payload),
    sizeof(vapi_msg_kp_conf),
    (generic_swap_fn_t)vapi_msg_kp_conf_hton,
    (generic_swap_fn_t)vapi_msg_kp_conf_ntoh,
    INVALID_MSG_ID,
  };

  vapi_msg_id_kp_conf = vapi_register_msg(&__vapi_metadata_kp_conf);
  VAPI_DBG("Assigned msg id %d to kp_conf", vapi_msg_id_kp_conf);
}

static void __attribute__((constructor)) __vapi_constructor_kp_add_del_pod()
{
  static const char name[] = "kp_add_del_pod";
  static const char name_with_crc[] = "kp_add_del_pod_ebddfbf7";
  static vapi_message_desc_t __vapi_metadata_kp_add_del_pod = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_kp_add_del_pod, payload),
    sizeof(vapi_msg_kp_add_del_pod),
    (generic_swap_fn_t)vapi_msg_kp_add_del_pod_hton,
    (generic_swap_fn_t)vapi_msg_kp_add_del_pod_ntoh,
    INVALID_MSG_ID,
  };

  vapi_msg_id_kp_add_del_pod = vapi_register_msg(&__vapi_metadata_kp_add_del_pod);
  VAPI_DBG("Assigned msg id %d to kp_add_del_pod", vapi_msg_id_kp_add_del_pod);
}

static void __attribute__((constructor)) __vapi_constructor_kp_add_del_pod_reply()
{
  static const char name[] = "kp_add_del_pod_reply";
  static const char name_with_crc[] = "kp_add_del_pod_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_kp_add_del_pod_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_kp_add_del_pod_reply, payload),
    sizeof(vapi_msg_kp_add_del_pod_reply),
    (generic_swap_fn_t)vapi_msg_kp_add_del_pod_reply_hton,
    (generic_swap_fn_t)vapi_msg_kp_add_del_pod_reply_ntoh,
    INVALID_MSG_ID,
  };

  vapi_msg_id_kp_add_del_pod_reply = vapi_register_msg(&__vapi_metadata_kp_add_del_pod_reply);
  VAPI_DBG("Assigned msg id %d to kp_add_del_pod_reply", vapi_msg_id_kp_add_del_pod_reply);
}

static void __attribute__((constructor)) __vapi_constructor_kp_add_del_vip()
{
  static const char name[] = "kp_add_del_vip";
  static const char name_with_crc[] = "kp_add_del_vip_5eeec36e";
  static vapi_message_desc_t __vapi_metadata_kp_add_del_vip = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_kp_add_del_vip, payload),
    sizeof(vapi_msg_kp_add_del_vip),
    (generic_swap_fn_t)vapi_msg_kp_add_del_vip_hton,
    (generic_swap_fn_t)vapi_msg_kp_add_del_vip_ntoh,
    INVALID_MSG_ID,
  };

  vapi_msg_id_kp_add_del_vip = vapi_register_msg(&__vapi_metadata_kp_add_del_vip);
  VAPI_DBG("Assigned msg id %d to kp_add_del_vip", vapi_msg_id_kp_add_del_vip);
}

static void __attribute__((constructor)) __vapi_constructor_kp_add_del_vip_reply()
{
  static const char name[] = "kp_add_del_vip_reply";
  static const char name_with_crc[] = "kp_add_del_vip_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_kp_add_del_vip_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_kp_add_del_vip_reply, payload),
    sizeof(vapi_msg_kp_add_del_vip_reply),
    (generic_swap_fn_t)vapi_msg_kp_add_del_vip_reply_hton,
    (generic_swap_fn_t)vapi_msg_kp_add_del_vip_reply_ntoh,
    INVALID_MSG_ID,
  };

  vapi_msg_id_kp_add_del_vip_reply = vapi_register_msg(&__vapi_metadata_kp_add_del_vip_reply);
  VAPI_DBG("Assigned msg id %d to kp_add_del_vip_reply", vapi_msg_id_kp_add_del_vip_reply);
}

static void __attribute__((constructor)) __vapi_constructor_kp_conf_reply()
{
  static const char name[] = "kp_conf_reply";
  static const char name_with_crc[] = "kp_conf_reply_e8d4e804";
  static vapi_message_desc_t __vapi_metadata_kp_conf_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_kp_conf_reply, payload),
    sizeof(vapi_msg_kp_conf_reply),
    (generic_swap_fn_t)vapi_msg_kp_conf_reply_hton,
    (generic_swap_fn_t)vapi_msg_kp_conf_reply_ntoh,
    INVALID_MSG_ID,
  };

  vapi_msg_id_kp_conf_reply = vapi_register_msg(&__vapi_metadata_kp_conf_reply);
  VAPI_DBG("Assigned msg id %d to kp_conf_reply", vapi_msg_id_kp_conf_reply);
}


static inline void vapi_set_vapi_msg_kp_add_del_pod_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_kp_add_del_pod_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_kp_add_del_pod_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_kp_add_del_vip_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_kp_add_del_vip_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_kp_add_del_vip_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_kp_conf_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_kp_conf_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_kp_conf_reply, (vapi_event_cb)callback, callback_ctx);
};


#ifdef __cplusplus
}
#endif

#endif
