#ifndef __included_hpp_kp_api_json
#define __included_hpp_kp_api_json

#include <vapi/vapi.hpp>
#include <vapi/kp.api.vapi.h>

namespace vapi {

template <> inline void vapi_swap_to_be<vapi_msg_kp_conf>(vapi_msg_kp_conf *msg)
{
  vapi_msg_kp_conf_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_kp_conf>(vapi_msg_kp_conf *msg)
{
  vapi_msg_kp_conf_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_kp_conf>()
{
  return ::vapi_msg_id_kp_conf; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_kp_conf>>()
{
  return ::vapi_msg_id_kp_conf; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_kp_conf()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_kp_conf>(vapi_msg_id_kp_conf);
}

template <> inline vapi_msg_kp_conf* vapi_alloc<vapi_msg_kp_conf>(Connection &con)
{
  vapi_msg_kp_conf* result = vapi_alloc_kp_conf(con.vapi_ctx);
#if VAPI_CPP_DEBUG_LEAKS
  con.on_shm_data_alloc(result);
#endif
  return result;
}

template class Msg<vapi_msg_kp_conf>;

template class Request<vapi_msg_kp_conf, vapi_msg_kp_conf_reply>;

using Kp_conf = Request<vapi_msg_kp_conf, vapi_msg_kp_conf_reply>;

template <> inline void vapi_swap_to_be<vapi_msg_kp_add_del_pod>(vapi_msg_kp_add_del_pod *msg)
{
  vapi_msg_kp_add_del_pod_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_kp_add_del_pod>(vapi_msg_kp_add_del_pod *msg)
{
  vapi_msg_kp_add_del_pod_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_kp_add_del_pod>()
{
  return ::vapi_msg_id_kp_add_del_pod; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_kp_add_del_pod>>()
{
  return ::vapi_msg_id_kp_add_del_pod; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_kp_add_del_pod()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_kp_add_del_pod>(vapi_msg_id_kp_add_del_pod);
}

template <> inline vapi_msg_kp_add_del_pod* vapi_alloc<vapi_msg_kp_add_del_pod>(Connection &con)
{
  vapi_msg_kp_add_del_pod* result = vapi_alloc_kp_add_del_pod(con.vapi_ctx);
#if VAPI_CPP_DEBUG_LEAKS
  con.on_shm_data_alloc(result);
#endif
  return result;
}

template class Msg<vapi_msg_kp_add_del_pod>;

template class Request<vapi_msg_kp_add_del_pod, vapi_msg_kp_add_del_pod_reply>;

using Kp_add_del_pod = Request<vapi_msg_kp_add_del_pod, vapi_msg_kp_add_del_pod_reply>;

template <> inline void vapi_swap_to_be<vapi_msg_kp_add_del_pod_reply>(vapi_msg_kp_add_del_pod_reply *msg)
{
  vapi_msg_kp_add_del_pod_reply_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_kp_add_del_pod_reply>(vapi_msg_kp_add_del_pod_reply *msg)
{
  vapi_msg_kp_add_del_pod_reply_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_kp_add_del_pod_reply>()
{
  return ::vapi_msg_id_kp_add_del_pod_reply; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_kp_add_del_pod_reply>>()
{
  return ::vapi_msg_id_kp_add_del_pod_reply; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_kp_add_del_pod_reply()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_kp_add_del_pod_reply>(vapi_msg_id_kp_add_del_pod_reply);
}

template class Msg<vapi_msg_kp_add_del_pod_reply>;

using Kp_add_del_pod_reply = Msg<vapi_msg_kp_add_del_pod_reply>;
template <> inline void vapi_swap_to_be<vapi_msg_kp_add_del_vip>(vapi_msg_kp_add_del_vip *msg)
{
  vapi_msg_kp_add_del_vip_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_kp_add_del_vip>(vapi_msg_kp_add_del_vip *msg)
{
  vapi_msg_kp_add_del_vip_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_kp_add_del_vip>()
{
  return ::vapi_msg_id_kp_add_del_vip; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_kp_add_del_vip>>()
{
  return ::vapi_msg_id_kp_add_del_vip; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_kp_add_del_vip()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_kp_add_del_vip>(vapi_msg_id_kp_add_del_vip);
}

template <> inline vapi_msg_kp_add_del_vip* vapi_alloc<vapi_msg_kp_add_del_vip>(Connection &con)
{
  vapi_msg_kp_add_del_vip* result = vapi_alloc_kp_add_del_vip(con.vapi_ctx);
#if VAPI_CPP_DEBUG_LEAKS
  con.on_shm_data_alloc(result);
#endif
  return result;
}

template class Msg<vapi_msg_kp_add_del_vip>;

template class Request<vapi_msg_kp_add_del_vip, vapi_msg_kp_add_del_vip_reply>;

using Kp_add_del_vip = Request<vapi_msg_kp_add_del_vip, vapi_msg_kp_add_del_vip_reply>;

template <> inline void vapi_swap_to_be<vapi_msg_kp_add_del_vip_reply>(vapi_msg_kp_add_del_vip_reply *msg)
{
  vapi_msg_kp_add_del_vip_reply_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_kp_add_del_vip_reply>(vapi_msg_kp_add_del_vip_reply *msg)
{
  vapi_msg_kp_add_del_vip_reply_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_kp_add_del_vip_reply>()
{
  return ::vapi_msg_id_kp_add_del_vip_reply; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_kp_add_del_vip_reply>>()
{
  return ::vapi_msg_id_kp_add_del_vip_reply; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_kp_add_del_vip_reply()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_kp_add_del_vip_reply>(vapi_msg_id_kp_add_del_vip_reply);
}

template class Msg<vapi_msg_kp_add_del_vip_reply>;

using Kp_add_del_vip_reply = Msg<vapi_msg_kp_add_del_vip_reply>;
template <> inline void vapi_swap_to_be<vapi_msg_kp_conf_reply>(vapi_msg_kp_conf_reply *msg)
{
  vapi_msg_kp_conf_reply_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_kp_conf_reply>(vapi_msg_kp_conf_reply *msg)
{
  vapi_msg_kp_conf_reply_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_kp_conf_reply>()
{
  return ::vapi_msg_id_kp_conf_reply; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_kp_conf_reply>>()
{
  return ::vapi_msg_id_kp_conf_reply; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_kp_conf_reply()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_kp_conf_reply>(vapi_msg_id_kp_conf_reply);
}

template class Msg<vapi_msg_kp_conf_reply>;

using Kp_conf_reply = Msg<vapi_msg_kp_conf_reply>;
}
#endif
